package main

import (
	"loafle.com/overflow/activedirectory_protocol_crawler_go"
	"loafle.com/overflow/crawler_go"
	"loafle.com/overflow/dns_protocol_crawler_go"
	"loafle.com/overflow/ftp_protocol_crawler_go"
	"loafle.com/overflow/ftps_protocol_crawler_go"
	"loafle.com/overflow/imap_protocol_crawler_go"
	"loafle.com/overflow/ldap_protocol_crawler_go"
	"loafle.com/overflow/mongodb_protocol_crawler_go"
	"loafle.com/overflow/mssql_protocol_crawler_go"
	"loafle.com/overflow/mysql_protocol_crawler_go"
	"loafle.com/overflow/netbios_protocol_crawler_go"
	"loafle.com/overflow/of_rpc_go"
	"loafle.com/overflow/oracle_protocol_crawler_go"
	"loafle.com/overflow/pgsql_protocol_crawler_go"
	"loafle.com/overflow/pop3_protocol_crawler_go"
	"loafle.com/overflow/redis_protocol_crawler_go"
	"loafle.com/overflow/rmi_protocol_crawler_go"
	"loafle.com/overflow/smb_protocol_crawler_go"
	"loafle.com/overflow/smtp_protocol_crawler_go"
	"loafle.com/overflow/snmpv2c_protocol_crawler_go"
	"loafle.com/overflow/snmpv3_protocol_crawler_go"
	"loafle.com/overflow/ssh_protocol_crawler_go"
	"loafle.com/overflow/telnet_protocol_crawler_go"
	"loafle.com/overflow/wmi_protocol_crawler_go"
	"log"
)

func initCrawlers() {
	of_rpc.AddDelegate(crawler.ACTIVEDIRECTORY.String(), activedirectory_protocol_crawler_go.NewActiveDirectoryHealthCrawler())
	of_rpc.AddDelegate(crawler.DNS.String(), dns_protocol_crawler_go.NewDNSHealthCrawler())
	of_rpc.AddDelegate(crawler.FTP.String(), ftp_protocol_crawler_go.NewFTPHealthCrawler())
	of_rpc.AddDelegate(crawler.FTPS.String(), ftps_protocol_crawler_go.NewFTPSHealthCrawler())
	of_rpc.AddDelegate(crawler.IMAP.String(), imap_protocol_crawler_go.NewIMAPHealthCrawler())
	of_rpc.AddDelegate(crawler.LDAP.String(), ldap_protocol_crawler_go.NewLDAPHealthCrawler())
	of_rpc.AddDelegate(crawler.MONGODB.String(), mongodb_protocol_crawler_go.NewMongoDBHealthCrawler())
	of_rpc.AddDelegate(crawler.MSSQL.String(), mssql_protocol_crawler_go.NewMSSqlHeahthCrawler())
	of_rpc.AddDelegate(crawler.MYSQL.String(), mysql_protocol_crawler_go.NewMysqlHeahthCrawler())
	of_rpc.AddDelegate(crawler.MARIADB.String(), mysql_protocol_crawler_go.NewMysqlHeahthCrawler())
	of_rpc.AddDelegate(crawler.PGSQL.String(), pgsql_protocol_crawler_go.NewPGSqlHeahthCrawler())
	of_rpc.AddDelegate(crawler.NETBIOS.String(), netbios_protocol_crawler_go.NewNetbiosHeahthCrawler())
	of_rpc.AddDelegate(crawler.ORACLE.String(), oracle_protocol_crawler_go.NewOracleHeahthCrawler())
	of_rpc.AddDelegate(crawler.POP3.String(), pop3_protocol_crawler_go.NewPOP3HeahthCrawler())
	of_rpc.AddDelegate(crawler.REDIS.String(), redis_protocol_crawler_go.NewRedisHeahthCrawler())
	of_rpc.AddDelegate(crawler.RMI.String(), rmi_protocol_crawler_go.NewRMIHeahthCrawler())
	of_rpc.AddDelegate(crawler.SMB.String(), smb_protocol_crawler_go.NewSMBHeahthCrawler())
	of_rpc.AddDelegate(crawler.SMTP.String(), smtp_protocol_crawler_go.NewSMTPHeahthCrawler())
	of_rpc.AddDelegate(crawler.SNMPV2C.String(), snmpv2c_protocol_crawler_go.NewSNMPV2CHeahthCrawler())
	of_rpc.AddDelegate(crawler.SNMPV3.String(), snmpv3_protocol_crawler_go.NewSNMPV3HeahthCrawler())
	of_rpc.AddDelegate(crawler.SSH.String(), ssh_protocol_crawler_go.NewSSHHeahthCrawler())
	of_rpc.AddDelegate(crawler.TELNET.String(), telnet_protocol_crawler_go.NewTelnetHeahthCrawler())
	of_rpc.AddDelegate(crawler.WMI.String(), wmi_protocol_crawler_go.NewWMIHeahthCrawler())
}

func start() {
	err := of_rpc.StartJSONRPC()
	if err != nil {
		log.Fatal(err)
	}
}

func main() {
	initCrawlers()
	start()
}
